// DesignDoc.cpp : implementation of the CDesignDoc class
//
//		From String table
//		\nDesign\nDesign\n\n\nDesign.Document\nDesign Document
//
#include "stdafx.h"
#include "Design.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define HEIGHT 9
/////////////////////////////////////////////////////////////////////////////
// CDesignDoc

IMPLEMENT_DYNCREATE(CDesignDoc, CDocument)

BEGIN_MESSAGE_MAP(CDesignDoc, CDocument)
	//{{AFX_MSG_MAP(CDesignDoc)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_VIEW_TRANSPARENT, OnViewTransparent)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TRANSPARENT, OnUpdateViewTransparent)
	ON_COMMAND(ID_ELEMENT_ROOM, OnElementRoom)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_ROOM, OnUpdateElementRoom)
	ON_COMMAND(ID_ELEMENT_CURSOR, OnElementCursor)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_CURSOR, OnUpdateElementCursor)
	ON_COMMAND(ID_ELEMENT_DOOR, OnElementDoor)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_DOOR, OnUpdateElementDoor)
	ON_COMMAND(ID_ELEMENT_WINDOW, OnElementWindow)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_WINDOW, OnUpdateElementWindow)
	ON_COMMAND(ID_ELEMENT_ROOF, OnElementRoof)
	ON_UPDATE_COMMAND_UI(ID_ELEMENT_ROOF, OnUpdateElementRoof)
	ON_COMMAND(ID_VIEW_WALKTHROUGH, OnViewWalkthrough)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WALKTHROUGH, OnUpdateViewWalkthrough)
	ON_COMMAND(ID_VIEW_NORMAL, OnViewNormal)
	ON_UPDATE_COMMAND_UI(ID_VIEW_NORMAL, OnUpdateViewNormal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDesignDoc construction/destruction

CDesignDoc::CDesignDoc()
{
	m_ElemSelected = -1;
	m_sel_pt_a = 0;
	m_sel_pt_b = 0;

	// TODO: add one-time construction code here
	m_xRotate = 0;
	m_yRotate = 90;
	m_sizeDoc = CSize(640, 640);

	m_Thickness = 2;
	m_Color = RGB(192,192,0);
	m_CurrentElement = 	ID_ELEMENT_CURSOR;
	m_Transparent = FALSE;
//////////////////////////////
	eyex = 0;
	eyey = 5;
	eyez = 100;

	centerx = 0;
	centery = 5;
	centerz = 99;

	m_xz_angle = 0;
	m_yz_angle = 0;

	m_CurrentMode = ID_VIEW_NORMAL;
}

CDesignDoc::~CDesignDoc()
{
}

BOOL CDesignDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CDesignDoc serialization

void CDesignDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		m_ElemArray.Serialize(ar);
	}
	else
	{
		// TODO: add loading code here
		m_ElemArray.Serialize(ar);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CDesignDoc diagnostics

#ifdef _DEBUG
void CDesignDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDesignDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDesignDoc commands
void CDesignDoc::RenderScene()
{
	GLfloat LightAmbient[] =  { 0.4f, 0.4f, 0.4f, 0.1f};
	GLfloat LightDiffuse[] =  { 1.0f, 1.0f, 1.0f, 0.7f};
	GLfloat LightSpecular[] = { 1.0f, 1.0f,	1.0f, 1.0f};
	GLfloat LightPosition[] = { eyex+3, eyey+3, eyez+3, 1.0f};
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpecular);
	glLightfv(GL_LIGHT0, GL_POSITION, LightPosition);
	glEnable(GL_LIGHT0);

	CRoof *pRoof;
	CPoint  topleft, bottomright;
	double top, left, bottom, right, height = 4; //, midpoint;
	double normalizex, normalizey;
	CElement *pElement;
	CRect	Temprect;
	int NumElem = GetNumElem();
	int i;


	glEnable(GL_COLOR_MATERIAL);
	if (m_Transparent)
	{
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	else
	{
		glDisable(GL_BLEND);
	}
	glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);

	glPushMatrix();
////////Translate and rotate to the proper position
		gluLookAt(eyex, eyey, eyez, centerx, centery, centerz, 0, 1, 0);
	
		glRotated(m_xRotate, 1.0, 0.0, 0.0);
		glRotated(m_yRotate, 0.0, 1.0, 0.0);
		glTranslated(-32, 0.0, -32);

////////Locate Doors
		glColor4f(0.6f, 0.4f, 0.1f, 1.0f);
		for (i = 0; i < NumElem; ++i)
		{
			pElement = GetElem(i);
			if (pElement->m_ElemType == DOOR)	// if it is a room
			{
				Temprect = pElement->GetDimRect();
				topleft = Temprect.TopLeft();
				top = (640 - topleft.y)/10.0;
				left = topleft.x/10.0;
				bottomright = Temprect.BottomRight();
				bottom = (640 - bottomright.y)/10.0;
				right = bottomright.x/10.0;
				if (abs(top - bottom) > abs(right - left))
				{
					glTranslated(bottom, 0.0, left + 0.8);
					glCallList(DOOR);
					glTranslated(-bottom, 0.0, -(left + 0.8));
				}
				else
				{
					glTranslated(bottom + 0.8, 0.0, left);
					glRotated(-90.0, 0.0, 1.0, 0.0);
					glCallList(DOOR);
					glRotated(90.0, 0.0, 1.0, 0.0);
					glTranslated(-(bottom + 0.8), 0.0, -left);
				}
			}

		}
////////Locate Windows
		glColor4f(0.5f, 0.5f, 0.9f, 1.0f);
		for (i = 0; i < NumElem; ++i)
		{
			pElement = GetElem(i);
			if (pElement->m_ElemType == WINDOW)	// if it is a room
			{
				Temprect = pElement->GetDimRect();
				topleft = Temprect.TopLeft();
				top = (640 - topleft.y)/10.0;
				left = (topleft.x)/10.0;
				bottomright = Temprect.BottomRight();
				bottom = (640 - bottomright.y)/10.0;
				right = (bottomright.x)/10.0;
				if (abs(top - bottom) > abs(right - left))
				{
					glTranslated(bottom, 2.4, (left + 0.8));
					glCallList(WINDOW);
					glTranslated(-bottom, -2.4, -(left + 0.8));
				}
				else
				{
					glTranslated((bottom + 0.8), 2.4, left);
					glRotated(-90.0, 0.0, 1.0, 0.0);
					glCallList(WINDOW);
					glRotated(90.0, 0.0, 1.0, 0.0);
					glTranslated(-(bottom + 0.8), -2.4, -left);
				}
			}
		}


////////Locate Rooms
		glColor4f(1.0f, 1.0f, 0.4f, 0.5f);
		for (i = 0; i < NumElem; ++i)
		{	
////////////Cannot use List because of distortion of lighting due to scaling
			pElement = GetElem(i);
			if (pElement->m_ElemType == ROOM)	// if it is a room
			{
				Temprect = pElement->GetDimRect();
				topleft = Temprect.TopLeft();
				top = (640 - topleft.y)/10.0;
				left = topleft.x/10.0;
				bottomright = Temprect.BottomRight();
				bottom = (640 - bottomright.y)/10.0;
				right = bottomright.x/10.0;
				glBegin(GL_QUADS);
					glNormal3d(  0.0,  0.0,  -1.0);
					glVertex3d(  top - 0.001,  0.0, left + 0.001);
					glVertex3d(  top - 0.001,  0.8*HEIGHT, left + 0.001);
					glVertex3d(  bottom + 0.001,  0.8*HEIGHT, left + 0.001);
					glVertex3d(  bottom + 0.001,  0.0, left + 0.001);
				glEnd();
				glBegin(GL_QUADS);
					glNormal3d(  0.0,  0.0,  1.0);
					glVertex3d(  top - 0.001,  0.0, right - 0.001);
					glVertex3d(  top - 0.001,  0.8*HEIGHT, right - 0.001);
					glVertex3d(  bottom + 0.001,  0.8*HEIGHT, right - 0.001);
					glVertex3d(  bottom + 0.001,  0.0, right - 0.001);
				glEnd();
				glBegin(GL_QUADS);
					glNormal3d(  1.0,  0.0,  0.0);
					glVertex3d(  top - 0.001,  0.0, left + 0.001);
					glVertex3d(  top - 0.001,  0.8*HEIGHT, left + 0.001);
					glVertex3d(  top - 0.001,  0.8*HEIGHT, right - 0.001);
					glVertex3d(  top - 0.001,  0.0, right - 0.001);
				glEnd();
				glBegin(GL_QUADS);
					glNormal3d(  -1.0,  0.0,  0.0);
					glVertex3d(  bottom + 0.001,  0.0, left + 0.001);
					glVertex3d(  bottom + 0.001,  0.8*HEIGHT, left + 0.001);
					glVertex3d(  bottom + 0.001,  0.8*HEIGHT, right - 0.001);
					glVertex3d(  bottom + 0.001,  0.0, right - 0.001);
				glEnd();

				glBegin(GL_QUADS);
					glNormal3d(  0.0,  0.0,  1.0);
					glVertex3d(  top - 0.003,  0.0, left + 0.003);
					glVertex3d(  top - 0.003,  0.8*HEIGHT, left + 0.003);
					glVertex3d(  bottom + 0.003,  0.8*HEIGHT , left + 0.003);
					glVertex3d(  bottom + 0.003,  0.0, left +0.003);
				glEnd();
				glBegin(GL_QUADS);
					glNormal3d(  0.0,  0.0,  -1.0);
					glVertex3d(  top - 0.003,  0.0, right - 0.003);
					glVertex3d(  top - 0.003,  0.8*HEIGHT, right - 0.003);
					glVertex3d(  bottom + 0.003,  0.8*HEIGHT, right - 0.003);
					glVertex3d(  bottom + 0.003,  0.0, right - 0.003);
				glEnd();
				glBegin(GL_QUADS);
					glNormal3d(  -1.0,  0.0,  0.0);
					glVertex3d(  top - 0.003,  0.0, left + 0.003);
					glVertex3d(  top - 0.003,  0.8*HEIGHT, left + 0.003);
					glVertex3d(  top - 0.003,  0.8*HEIGHT, right - 0.003);
					glVertex3d(  top - 0.003,  0.0, right - 0.003);
				glEnd();
				glBegin(GL_QUADS);
					glNormal3d(  1.0,  0.0,  0.0);
					glVertex3d(  bottom + 0.003,  0.0, left + 0.003);
					glVertex3d(  bottom + 0.003,  0.8*HEIGHT, left + 0.003);
					glVertex3d(  bottom + 0.003,  0.8*HEIGHT, right - 0.003);
					glVertex3d(  bottom + 0.003,  0.0, right - 0.003);
				glEnd();
			}
		}

////////Locate Roofs
		glColor4f(0.8f, 0.2f, 0.1f, 0.5f);
		for (i = 0; i < NumElem; ++i)
		{	
////////////Cannot use List because of distortion of lighting due to scaling
			pElement = GetElem(i);
			if (pElement->m_ElemType == ROOF)	// if it is a roof
			{
				pRoof = (CRoof*)GetElem(i);
				Temprect = pRoof->GetDimRect();

				topleft = Temprect.TopLeft();
				top = (640 - topleft.y)/10.0;
				left = topleft.x/10.0;
				bottomright = Temprect.BottomRight();
				bottom = (640 - bottomright.y)/10.0;
				right = bottomright.x/10.0;

				glBegin(GL_QUADS);
					glNormal3d(  0.0,  -1.0,  0.0);
					glVertex3d(  top,  0.8*HEIGHT, left);
					glVertex3d(  top,  0.8*HEIGHT, right);
					glVertex3d(  bottom,  0.8*HEIGHT, right);
					glVertex3d(  bottom,  0.8*HEIGHT, left);
				glEnd();

				switch(pRoof->m_Dir)
				{
				case UP:
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );
					glBegin(GL_QUADS);
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
					glEnd();
					glBegin(GL_QUADS);
						glNormal3d( 0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , right );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , left );
					glEnd();
					break;
				case DOWN:
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );
					glBegin(GL_QUADS);
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
					glEnd();
					glBegin(GL_QUADS);
						glNormal3d( -0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
					glEnd();
					break;
				case LEFT:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					glBegin(GL_QUADS);
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
					glEnd();
					glBegin(GL_QUADS);
						glNormal3d(0.0 , height/normalizex, -0.5*abs(right-left) / normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
					glEnd();
					break;
				case RIGHT:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					glBegin(GL_QUADS);
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
					glEnd();
					glBegin(GL_QUADS);
						glNormal3d(0.0 , height/normalizex, 0.5*abs(right-left)/normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , right );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
					glEnd();
					break;
				case LEFTUP:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );

					glBegin(GL_TRIANGLES);
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );

						glNormal3d(0.0 , height/normalizex, -0.5*abs(right-left) / normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , left );

						glNormal3d( 0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , right );
					glEnd();
					break;
				case LEFTDOWN:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );
					
					glBegin(GL_TRIANGLES);
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );

						glNormal3d(0.0 , height/normalizex, -0.5*abs(right-left) / normalizex);
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
					
						glNormal3d( -0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
					glEnd();
					break;
				case RIGHTUP:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );

					glBegin(GL_TRIANGLES);
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );

						glNormal3d( 0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , right );

						glNormal3d(0.0 , height/normalizex, 0.5*abs(right-left)/normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , right );
					glEnd();
					break;
				case RIGHTDOWN:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );

					glBegin(GL_TRIANGLES);
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );

						glNormal3d( -0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );

						glNormal3d(0.0 , height/normalizex, 0.5*abs(right-left)/normalizex);
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
					glEnd();
					break;
				case HIGHLEFTUP:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );
					glBegin(GL_QUADS);
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glNormal3d( 0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glNormal3d(0.0 , height/normalizex, -0.5*abs(right-left) / normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(top , 0.8*HEIGHT , left );
					glEnd();
					break;
				case HIGHLEFTDOWN:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );
					glBegin(GL_QUADS);
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );

						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glNormal3d(0.0 , height/normalizex, -0.5*abs(right-left) / normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glNormal3d( -0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , left );
					glEnd();
					break;
				case HIGHRIGHTUP:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );					glBegin(GL_QUADS);
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glNormal3d( 0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(bottom , (0.8*HEIGHT + height) , right );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , right );
						glNormal3d(0.0 , height/normalizex, 0.5*abs(right-left)/normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(top , 0.8*HEIGHT , right );
					glEnd();
					break;
				case HIGHRIGHTDOWN:
					normalizex = sqrt(height*height + (0.5*abs(right-left))*(0.5*abs(right-left)) );
//					normalizey = max(height, 0.5*abs(top-bottom) );
					normalizey = sqrt(height*height + (0.5*abs(top-bottom))*(0.5*abs(top-bottom)) );					glBegin(GL_QUADS);
						glNormal3d(1.0, 0.0, 0.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glNormal3d(0.0, 0.0, -1.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(top , 0.8*HEIGHT , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
					glEnd();
					glBegin(GL_TRIANGLES);
						glNormal3d(-1.0, 0.0, 0.0);
						glVertex3d(bottom , 0.8*HEIGHT , left );
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glNormal3d(0.0, 0.0, 1.0);
						glVertex3d(top , 0.8*HEIGHT , right );
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glNormal3d( -0.5*abs(top-bottom)/normalizey, height/normalizey, 0.0);
						glVertex3d(top , (0.8*HEIGHT + height) , right );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
						glNormal3d(0.0 , height/normalizex, 0.5*abs(right-left)/normalizex);
						glVertex3d(bottom , (0.8*HEIGHT + height) , left );
						glVertex3d(top , (0.8*HEIGHT + height) , left );
						glVertex3d(bottom , 0.8*HEIGHT , right );
					glEnd();
					break;
				}
			}
		}
////////Locate the base
		glColor4f(0.0f, 0.7f, 0.0f, 0.5f);
		glBegin(GL_QUADS);
			glNormal3d(  0.0,  1.0,  0.0);
			glVertex3d(  64,  0.0, 0.0);
			glVertex3d(  64,  0.0, 64);
			glVertex3d(  0.0,  0.0, 64);
			glVertex3d(  0.0,  0.0, 0.0);
		glEnd();

	glPopMatrix();

}

void CDesignDoc::AddElem(CElement *pElement)
{
	m_ElemArray.Add(pElement);
	SetModifiedFlag();
}

CElement *CDesignDoc::GetElem(int Index)
{
	if (Index < 0 || Index > m_ElemArray.GetUpperBound())
		return 0;
	return (CElement *)m_ElemArray.GetAt(Index);
}

int CDesignDoc::GetNumElem()
{
	return m_ElemArray.GetSize();
}

void CDesignDoc::OnEditUndo() 
{
	// TODO: Add your command handler code here
	int Index = m_ElemArray.GetUpperBound();
	if (Index > -1)
	{
		delete m_ElemArray.GetAt(Index);
		m_ElemArray.RemoveAt(Index);
	}
	UpdateAllViews(0);
	SetModifiedFlag();
}

void CDesignDoc::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_ElemArray.GetSize());
}

void CDesignDoc::OnViewTransparent() 
{
	// TODO: Add your command handler code here
	m_Transparent = !m_Transparent;
	UpdateAllViews(NULL, 0);
}

void CDesignDoc::OnUpdateViewTransparent(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Transparent);
}

void CDesignDoc::OnElementRoom() 
{
	// TODO: Add your command handler code here
	m_Thickness = 2;
	m_Color = RGB(192,192,0);
	m_ElemSelected = -1;
	m_sel_pt_a = 0;
	m_sel_pt_b = 0;
	if (m_CurrentElement != ID_ELEMENT_ROOM)
	{
		m_CurrentElement = ID_ELEMENT_ROOM;
		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateElementRoom(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentElement == ID_ELEMENT_ROOM ? 1 : 0);
}

void CDesignDoc::OnElementCursor() 
{
	// TODO: Add your command handler code here
	m_ElemSelected = -1;
	m_sel_pt_a = 0;
	m_sel_pt_b = 0;
	if (m_CurrentElement != ID_ELEMENT_CURSOR)
	{
		m_CurrentElement = ID_ELEMENT_CURSOR;
		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateElementCursor(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentElement == ID_ELEMENT_CURSOR ? 1 : 0);
}

void CDesignDoc::OnElementDoor() 
{
	// TODO: Add your command handler code here
	m_Thickness = 3;
	m_Color = RGB(154,102,26);
	m_ElemSelected = -1;
	m_sel_pt_a = 0;
	m_sel_pt_b = 0;
	if (m_CurrentElement != ID_ELEMENT_DOOR)
	{
		m_CurrentElement = ID_ELEMENT_DOOR;
		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateElementDoor(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentElement == ID_ELEMENT_DOOR ? 1 : 0);
}

void CDesignDoc::OnElementWindow() 
{
	// TODO: Add your command handler code here
	m_Thickness = 3;
	m_Color = RGB(0,0,192);
	m_ElemSelected = -1;
	m_sel_pt_a = 0;
	m_sel_pt_b = 0;
	if (m_CurrentElement != ID_ELEMENT_WINDOW)
	{
		m_CurrentElement = ID_ELEMENT_WINDOW;
		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateElementWindow(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentElement == ID_ELEMENT_WINDOW ? 1 : 0);	
}

void CDesignDoc::OnElementRoof() 
{
	// TODO: Add your command handler code here
	m_Thickness = 1;
	m_Color = RGB(192, 0, 0);
	m_ElemSelected = -1;
	m_sel_pt_a = 0;
	m_sel_pt_b = 0;
	if (m_CurrentElement != ID_ELEMENT_ROOF)
	{
		m_CurrentElement = ID_ELEMENT_ROOF;
		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateElementRoof(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentElement == ID_ELEMENT_ROOF ? 1 : 0);
}

void CDesignDoc::OnViewWalkthrough() 
{
	// TODO: Add your command handler code here
	if (m_CurrentMode != ID_VIEW_WALKTHROUGH)
	{
		m_xRotate = 0;
		m_yRotate = 90;
		m_CurrentMode = ID_VIEW_WALKTHROUGH;
		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateViewWalkthrough(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentMode == ID_VIEW_WALKTHROUGH ? 1 : 0);	
}

void CDesignDoc::OnViewNormal() 
{
	// TODO: Add your command handler code here

	if (m_CurrentMode != ID_VIEW_NORMAL)
	{
		m_CurrentMode = ID_VIEW_NORMAL;
		eyex = 0;
		eyey = 5;
		eyez = 100;
		centerx = 0;
		centery = 5;
		centerz = 99;
		m_xz_angle = 0;
		m_yz_angle = 0;

		UpdateAllViews(NULL, 0);
	}
}

void CDesignDoc::OnUpdateViewNormal(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentMode == ID_VIEW_NORMAL ? 1 : 0);	
}





///////////////////////////////////////////////////////////////////////////////
// Implement CElement
IMPLEMENT_SERIAL (CElement, CObject, 1)

CRect CElement::GetDimRect()
{
	return CRect(	min(m_X1, m_X2),
					min(m_Y1, m_Y2),
					max(m_X1, m_X2),
					max(m_Y1, m_Y2));
}

void CElement::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
		ar << m_X1 << m_Y1 << m_X2 << m_Y2 << m_Color << m_Thickness;
	else
		ar >> m_X1 >> m_Y1 >> m_X2 >> m_Y2 >> m_Color >> m_Thickness;
}

///////////////////////////////////////////////////////////////////////////////
// Implement CRoom
IMPLEMENT_SERIAL (CRoom, CElement, 1)

CRoom::CRoom(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness)
{
	m_X1 = min(X1, X2);
	m_Y1 = min(Y1, Y2);
	m_X2 = max(X1, X2);
	m_Y2 = max(Y1, Y2);
	m_Color = Color;
	m_Thickness = Thickness;
	m_ElemType = ROOM;
}

void CRoom::Serialize(CArchive& ar)
{
	CElement::Serialize(ar);
	if (ar.IsStoring())
		ar << m_ElemType;
	else
		ar >> m_ElemType;
}

void CRoom::Draw(CDC *pDC)
{
	CPen Pen, *pOldPen;

	Pen.CreatePen(PS_INSIDEFRAME, m_Thickness, m_Color);
	pOldPen = pDC->SelectObject(&Pen);
	pDC->SelectStockObject(NULL_BRUSH);

	pDC->Rectangle(m_X1, m_Y1, m_X2 + 1, m_Y2 + 1);

	pDC->SelectObject(pOldPen);
}

///////////////////////////////////////////////////////////////////////////////
// Implement CDoor
IMPLEMENT_SERIAL (CDoor, CElement, 1)

CDoor::CDoor(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness)
{
	m_X1 = min(X1, X2);
	m_Y1 = min(Y1, Y2);
	m_X2 = max(X1, X2);
	m_Y2 = max(Y1, Y2);
	m_Color = Color;
	m_Thickness = Thickness;
	m_ElemType = DOOR;
}

void CDoor::Serialize(CArchive& ar)
{
	CElement::Serialize(ar);
	if (ar.IsStoring())
		ar << m_ElemType;
	else
		ar >> m_ElemType;
}

void CDoor::Draw(CDC *pDC)
{
	CPen Pen, *pOldPen;

	Pen.CreatePen(PS_INSIDEFRAME, m_Thickness, m_Color);
	pOldPen = pDC->SelectObject(&Pen);
	pDC->SelectStockObject(NULL_BRUSH);

	if (abs(m_X1 - m_X2) > abs(m_Y1 - m_Y2))
	{
		pDC->MoveTo(m_X1, m_Y1 + 8);
		pDC->LineTo(m_X2, m_Y1 + 8);
		pDC->LineTo(m_X1 + 8, m_Y1);
	}
	else
	{
		pDC->MoveTo(m_X1 + 8, m_Y1);
		pDC->LineTo(m_X1 + 8, m_Y2);
		pDC->LineTo(m_X1, m_Y1 + 8);
	}

	pDC->SelectObject(pOldPen);
}

///////////////////////////////////////////////////////////////////////////////
// Implement CWindow
IMPLEMENT_SERIAL (CWindow, CElement, 1)

CWindow::CWindow(int X1, int Y1, int X2, int Y2, int outxy, COLORREF Color, int Thickness)
{
	m_X1 = min(X1, X2);
	m_Y1 = min(Y1, Y2);
	m_X2 = max(X1, X2);
	m_Y2 = max(Y1, Y2);
	m_OutXY = outxy;
	m_Color = Color;
	m_Thickness = Thickness;
	m_ElemType = WINDOW;
}

void CWindow::Serialize(CArchive& ar)
{
	CElement::Serialize(ar);
	if (ar.IsStoring())
		ar << m_OutXY << m_ElemType;
	else
		ar >> m_OutXY >> m_ElemType;
}

void CWindow::Draw(CDC *pDC)
{
	CPen Pen, *pOldPen;

	Pen.CreatePen(PS_INSIDEFRAME, m_Thickness, m_Color);
	pOldPen = pDC->SelectObject(&Pen);
	pDC->SelectStockObject(NULL_BRUSH);

	if (m_OutXY == OPENLEFT)
	{
		pDC->MoveTo(m_X1, m_Y1);
		pDC->LineTo(m_X1 + 8, m_Y1);
		pDC->LineTo(m_X1 + 8, m_Y2);
		pDC->LineTo(m_X1, m_Y2);
	}
	else if (m_OutXY == OPENRIGHT)
	{
		pDC->MoveTo(m_X2, m_Y1);
		pDC->LineTo(m_X2 - 8, m_Y1);
		pDC->LineTo(m_X2 - 8, m_Y2);
		pDC->LineTo(m_X2, m_Y2);
	}
	else if (m_OutXY == OPENDOWN)
	{
		pDC->MoveTo(m_X1, m_Y2);
		pDC->LineTo(m_X1, m_Y2 - 8);
		pDC->LineTo(m_X2, m_Y2 - 8);
		pDC->LineTo(m_X2, m_Y2);
	}
	else
	{
		pDC->MoveTo(m_X1, m_Y1);
		pDC->LineTo(m_X1, m_Y1 + 8);
		pDC->LineTo(m_X2, m_Y1 + 8);
		pDC->LineTo(m_X2, m_Y1);
	}
	pDC->SelectObject(pOldPen);
}

///////////////////////////////////////////////////////////////////////////////
// Implement CRoof
IMPLEMENT_SERIAL (CRoof, CElement, 1)

CRoof::CRoof(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness, int Direction)
{
	m_X1 = min(X1, X2);
	m_Y1 = min(Y1, Y2);
	m_X2 = max(X1, X2);
	m_Y2 = max(Y1, Y2);
	m_Color = Color;
	m_Thickness = Thickness;
	m_Dir = Direction;
	m_ElemType = ROOF;
}

void CRoof::Serialize(CArchive& ar)
{
	CElement::Serialize(ar);
	if (ar.IsStoring())
		ar << m_Dir << m_ElemType;
	else
		ar >> m_Dir >> m_ElemType;
}

void CRoof::Draw(CDC *pDC)
{
	CPen Pen, Pen2, *pOldPen;

	Pen.CreatePen(PS_INSIDEFRAME, m_Thickness, RGB(250,220,220));
	pOldPen = pDC->SelectObject(&Pen);
	pDC->SelectStockObject(NULL_BRUSH);

	for (int i = (int)m_X1; i <= (int)m_X2; i = i + 4)
	{
		pDC->MoveTo(i, m_Y1);
		pDC->LineTo(i, m_Y2);
	}
	for (i = (int)m_Y1; i <= (int)m_Y2; i = i + 4)
	{
		pDC->MoveTo(m_X1, i);
		pDC->LineTo(m_X2, i);
	}
	pDC->SelectObject(pOldPen);


	Pen2.CreatePen(PS_INSIDEFRAME, m_Thickness, m_Color);
	pOldPen = pDC->SelectObject(&Pen2);
	pDC->Rectangle(m_X1, m_Y1, m_X2 + 1, m_Y2 + 1);
	pDC->SelectObject(pOldPen);
}


