// DesignView.h : interface of the CDesignView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DESIGNVIEW_H__BB3E885E_C092_11D1_9F93_000000000000__INCLUDED_)
#define AFX_DESIGNVIEW_H__BB3E885E_C092_11D1_9F93_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDesignView : public CScrollView
{
protected: // create from serialization only
	CDesignView();
	DECLARE_DYNCREATE(CDesignView)

// Attributes
public:
	CDesignDoc* GetDocument();

// Operations
public:
	HCURSOR	m_HArrow;
	HCURSOR m_HCross;
	int m_Dragging;
	CPoint m_PointOld;
	CPoint m_PointOrigin;
	CString m_Classname;
	CPen m_PenDotted;
	int m_ElemSelected;

	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDesignView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_Deletable;
	CPoint m_sel_pt_b;
	CPoint m_sel_pt_a;
	CPoint m_CurPos;
	virtual ~CDesignView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDesignView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEditDelete();
	afx_msg void OnUpdateEditDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateWidthHeight(CCmdUI *pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DesignView.cpp
inline CDesignDoc* CDesignView::GetDocument()
   { return (CDesignDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CModelView view

class CModelView : public CView
{
protected:
	CModelView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CModelView)

// Attributes
public:
	CPoint m_RDownPos;
	BOOL m_RButtonDown;
	CPoint m_LDownPos;
	BOOL m_LButtonDown;

// Operations
public:
	BOOL m_BuildList;
	BOOL CreateViewGLContext(HDC hDC);
	CDesignDoc* GetDocument();
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CModelView)
	public:
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CModelView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	HGLRC m_hGLContext;
	int m_GLPixelIndex;
	BOOL SetWindowPixelFormat(HDC hDC);
	//{{AFX_MSG(CModelView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DesignView.cpp
inline CDesignDoc* CModelView::GetDocument()
   { return (CDesignDoc*)m_pDocument; }
#endif


/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DESIGNVIEW_H__BB3E885E_C092_11D1_9F93_000000000000__INCLUDED_)
